/*
    dict.cpp
    $Id: dict.cpp,v 1.2 2014/11/28 23:55:45 daichi Exp $

*/
#include <cstdio>
#include <string>
#include "dict.h"
#include "util.h"

using namespace std;

typedef hash_map<string,int>::iterator diterator;
typedef hash_map<int,string>::iterator rditerator;

int
dictionary::id (string &s)
{
	diterator it;

	if ((it = hash.find(s)) == hash.end())
	{
		seed++;	// id from 1
		hash.insert (cons(s, seed));
		rhash.insert (cons(seed, s));
		return seed;
	} else {
		return it->second;
	}
}

string
dictionary::word (int w)
{
	rditerator it;

	if ((it = rhash.find(w)) == rhash.end())
	{
		return "";
	} else {
		return it->second;
	}
}

int
dictionary::size ()
{
	return seed;
}

void
dictionary::print ()
{
	int v, V = size();

	for (v = 1; v <= V; v++)
	{
		printf("dict[%2d] = %s\n", v, word(v).c_str());
	}
}

void
dictionary::save (char *file)
{
	int v, V = size();
	FILE *fp;

	if ((fp = fopen(strconcat(file, ".dic"), "w")) == NULL)
	{
		perror("fopen");
		return;
	}

	for (v = 1; v <= V; v++)
	{
		fprintf(fp, "%d\t%s\n", v, word(v).c_str());
	}

	fclose(fp);
}
			

#if 0

int
main (int argc, char *argv[])
{
	dictionary dict;
	int i;

	for (i = 1; i < argc; i++)
	{
		string w = argv[i];
		printf("id[%s] = %d\n", w.c_str(), dict.id(w));
	}
	for (i = 1; i <= dict.size(); i++)
	{
		printf("id %d -> %s\n", i, dict.word(i).c_str());
	}
		
	printf("size of dictionary = %d\n", dict.size());

	dict.save ("hoge");
	
}


#endif


	
